$<PDPRSX
GET "LIBHDR"
GET "SPEHDR"
$>PDPRSX

$<CAP1
GET "LIBHDR"
GET ".progs.spehdr"
$>CAP1

LET do.corrections () BE			// re-read input and do corrections
$(
    LET word = VEC wordsperword
    LET post = VEC wordsperword
    LET o = OUTPUT()
    LET c = ?

    Selectoutput(SYSOUT)
    Writes("  (starting correction pass)*N")
    Selectoutput(o)

    $(
	Read.input.word( TRUE, word, post )
	c := findword (word)			// have we a correction?

	TEST c = 0 THEN writes (word)				// no
		   ELSE writes( c + (c+1)%0/BYTESPERWORD + 2 )	// yes
	Writes(post)

    $)  REPEATUNTIL TERMINATOR=ENDSTREAMCH
$)


AND findword (string) = VALOF
$(
    LET node = correction.list			// skip down
    UNTIL node = 0 DO
    $(
        LET d = comparestring (string, node +1)
	SWITCHON d INTO
	$(cases
	CASE +1:
	    RESULTIS 0				// it's in inverse sorted order...
	CASE 0:
	    RESULTIS node			// found
	CASE -1:
	    node := node!0			// skip down
	    LOOP
	$)cases
    $)
    RESULTIS node				// ie 0 - not there
$)

AND remember.correction( word, new ) BE
$(
    LET size1 = 2 + (word%0)/BYTESPERWORD	// add node to correction list
    LET size  = size1 + (new%0)/BYTESPERWORD
    LET node  = GETVEC( size )
	TEST node<0
	THEN $(
		LET o = OUTPUT()

		Selectoutput(SYSOUT)
		Writes("No memory for this or further corrections*N")
		Selectoutput(o)
	     $)
	ELSE $(
		node!0 := correction.list
		correction.list := node
		FOR I=0 TO word%0 DO (node+1)%I := word%I
		FOR I=0 TO new%0  DO (node+size1)%I := new%I
	     $)
$)
